# frozen_string_literal: true

#
# Cookbook:: cronic
# Library:: provider/cronic_debian
#
# Copyright:: 2013, Tyler Technologies
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

require_relative 'cronic'

class Chef
  class Provider
    # A Cronic provider for Debian-ish platforms.
    class CronicDebian < Cronic
      provides :cronic, platform_family: 'debian'

      # Ensure the cron package is installed before proceeding.
      def load_current_resource
        unless ::File.exist?('/usr/bin/crontab')
          declare_resource(:apt_update, 'default').run_action(:periodic)
          declare_resource(:package, 'cron').run_action(:install)
        end

        super()
      end
    end
  end
end
